pub fn decode_zone_memoire( ZDonneesSortie: *mut std::ffi::c_void,TTailleDonneesSortie: usize){

    println!("Taille sortie SSV_LireCartePS : {}", TTailleDonneesSortie);
    println!("ZDonneesSortie: {:?}", ZDonneesSortie);

    // Convertir le pointeur en tranche de bytes
    let bytes: &[u8] = unsafe {
        std::slice::from_raw_parts(ZDonneesSortie as *const u8, TTailleDonneesSortie)
    };

    // Maintenant, vous pouvez accéder aux octets individuels dans `donnees`
    for &octet in bytes {
        println!("Octet: {}", octet);
    }

    let mut current_pos_general = 0;
    let mut current_groupe = 0;
    let mut num_champ = 0;

    while current_pos_general < bytes.len() - 1 {
        num_champ = 0;
        current_groupe = 256 * bytes[current_pos_general] as i32 + bytes[current_pos_general + 1] as i32;
        current_pos_general += 2;

        let longueur_groupe: usize;
        if bytes[current_pos_general] < 128 {
            longueur_groupe = bytes[current_pos_general] as usize;
        } else {
            let nbre_octets_longueur = bytes[current_pos_general] - 128;
            longueur_groupe = (0..nbre_octets_longueur)
                .fold(0, |acc, i| {
                    current_pos_general += 1;
                    acc + (256_i32.pow(i as u32) * bytes[current_pos_general] as i32) as usize
                });
        }
        current_pos_general += 1;

        let mut current_pos_groupe = 0;
        while current_pos_groupe < longueur_groupe {
            num_champ += 1;
            let longueur_champs: usize;
            let nbre_octets_longueur: usize;
            if bytes[current_pos_general] < 128 {
                longueur_champs = bytes[current_pos_general] as usize;
                nbre_octets_longueur = 1;
            } else {
                nbre_octets_longueur = bytes[current_pos_general] as usize - 128;
                longueur_champs = (0..nbre_octets_longueur)
                    .fold(0, |acc, i| {
                        current_pos_general += 1;
                        current_pos_groupe += 1;
                        acc + (256_i32.pow(i as u32) * bytes[current_pos_general] as i32) as usize
                    });
            }

            let mut bytes_champ = vec![0; longueur_champs];
            if longueur_champs > 0 {
                bytes_champ.copy_from_slice(&bytes[current_pos_general + nbre_octets_longueur..current_pos_general + nbre_octets_longueur + longueur_champs]);

                match current_groupe {
                    1 => match num_champ {
                        1 => println!("Groupe1.Champ1: {}", String::from_utf8_lossy(&bytes_champ)),
                        2 => println!("Groupe1.Champ2: {}", String::from_utf8_lossy(&bytes_champ)),
                        3 => println!("Groupe1.Champ3: {}", String::from_utf8_lossy(&bytes_champ)),
                        4 => println!("Groupe1.Champ4: {}", String::from_utf8_lossy(&bytes_champ)),
                        5 => println!("Groupe1.Champ5: {}", String::from_utf8_lossy(&bytes_champ)),
                        6 => println!("Groupe1.Champ6: {}", String::from_utf8_lossy(&bytes_champ)),
                        7 => println!("Groupe1.Champ7: {}", String::from_utf8_lossy(&bytes_champ)),
                        8 => println!("Groupe1.Champ8: {}", String::from_utf8_lossy(&bytes_champ)),
                        _ => (),
                    },
                    2 => match num_champ {
                        1 => {
                            // Ajoutez votre logique pour Groupe2 ici
                        }
                        2 => {
                            // Ajoutez votre logique pour Groupe2 ici
                        }
                        3 => {
                            // Ajoutez votre logique pour Groupe2 ici
                        }
                        _ => (),
                    },
                    _ => (),
                }
            }

            current_pos_general += longueur_champs + nbre_octets_longueur;
            current_pos_groupe += longueur_champs + nbre_octets_longueur;
        }
    }
}


